
namespace Compiler.Data
{
    /// <summary>
    /// Reg
    /// </summary>
    public enum ContentType : byte
    {
        /// <summary>
        /// X^[gReg 0x00 (terminal)
        /// </summary>
        Start = 0x00,
        /// <summary>
        /// X^[gNReg 0x01 (terminal) 
        /// </summary>
        LinkStart = 0x01,
        /// <summary>
        /// ogReg 0x02 (terminal)
        /// </summary>
        Battle = 0x02,
        /// <summary>
        /// IReg 0x03 (terminal) 
        /// </summary>
        End = 0x03,
        /// <summary>
        /// Q[I[o[Reg 0x04 (terminal)
        /// </summary>
        GameOver = 0x04,
        /// <summary>
        /// GAړReg 0x05 (terminal) 
        /// </summary>
        ChangeArea = 0x05,
        /// <summary>
        /// bZ[WReg 0x06 (standard)
        /// </summary>
        Message = 0x06,
        /// <summary>
        /// aflReg 0x07 (standard) 
        /// </summary>
        PlayBgm = 0x07,
        /// <summary>
        /// wiύXReg 0x08 (standard)
        /// </summary>
        ViewChange = 0x08,
        /// <summary>
        /// ʉReg 0x09 (standard)
        /// </summary>
        PlaySound = 0x09,
        /// <summary>
        /// 󔒎ԃReg 0x0a (standard) 
        /// </summary>
        Wait = 0x0a,
        /// <summary>
        /// ʃReg 0x0b (standard)
        /// </summary>
        Effect = 0x0b,
        /// <summary>
        /// oIReg 0x0c (utility) 
        /// </summary>
        MemberSelect = 0x0c,
        /// <summary>
        /// \͔Reg 0x0d (utility) 
        /// </summary>
        AbilityCheck = 0x0d,
        /// <summary>
        /// _Reg 0x0e (utility) 
        /// </summary>
        BranchRandom = 0x0e,
        /// <summary>
        /// tOReg 0x0f (data) 
        /// </summary>
        BranchFlag = 0x0f,

        /// <summary>
        /// tOύXReg 0x10 (data) 
        /// </summary>
        SetFlag = 0x10,
        /// <summary>
        /// Xebv򕪊Reg 0x11 (data) 
        /// </summary>
        BranchMultiStep = 0x11,
        /// <summary>
        /// XebvύXReg 0x12 (data) 
        /// </summary>
        SetStep = 0x12,
        /// <summary>
        /// LXgReg 0x13 (branch) 
        /// </summary>
        BranchCast = 0x13,
        /// <summary>
        /// ACeReg 0x14 (branch) 
        /// </summary>
        BranchItem = 0x14,
        /// <summary>
        /// Z\Reg 0x15 (branch) 
        /// </summary>
        BranchSkill = 0x15,
        /// <summary>
        /// 񕪊Reg 0x16 (branch) 
        /// </summary>
        BranchInfo = 0x16,
        /// <summary>
        /// bReg 0x17 (branch) 
        /// </summary>
        BranchBeast = 0x17,
        /// <summary>
        /// Reg 0x18 (branch) 
        /// </summary>
        BranchMoney = 0x18,
        /// <summary>
        /// N[|Reg 0x19 (branch)
        /// </summary>
        BranchCoupon = 0x19,
        /// <summary>
        /// LXgReg 0x1a (get) 
        /// </summary>
        GetCast = 0x1a,
        /// <summary>
        /// ACeReg 0x1b (get) 
        /// </summary>
        GetItem = 0x1b,
        /// <summary>
        /// Z\Reg 0x1c (get) 
        /// </summary>
        GetSkill = 0x1c,
        /// <summary>
        /// Reg 0x1d (get) 
        /// </summary>
        GetInfo = 0x1d,
        /// <summary>
        /// bReg 0x1e (get)
        /// </summary>
        GetBeast = 0x1e,
        /// <summary>
        /// Reg 0x1f (get)
        /// </summary>
        GetMoney = 0x1f,

        /// <summary>
        /// N[|擾Reg 0x20 (get) 
        /// </summary>
        GetCoupon = 0x20,
        /// <summary>
        /// LXgEReg 0x21 (lost) 
        /// </summary>
        LostCast = 0x21,
        /// <summary>
        /// ACerReg 0x22 (lost) 
        /// </summary>
        LostItem = 0x22,
        /// <summary>
        /// Z\rReg 0x23 (lost) 
        /// </summary>
        LostSkill = 0x23,
        /// <summary>
        /// rReg 0x24 (lost) 
        /// </summary>
        LostInfo = 0x24,
        /// <summary>
        /// brReg 0x25 (lost) 
        /// </summary>
        LostBeast = 0x25,
        /// <summary>
        /// Reg 0x26 (lost) 
        /// </summary>
        LostMoney = 0x26,
        /// <summary>
        /// N[|rReg 0x27 (lost) 
        /// </summary>
        LostCoupon = 0x27,
        /// <summary>
        /// ZtReg 0x28 (standard)
        /// </summary>
        Serif = 0x28,
        /// <summary>
        /// XebvReg 0x29 (data)
        /// </summary>
        SetStepUp = 0x29,
        /// <summary>
        /// XebvReg 0x2a (data) 
        /// </summary>
        SetStepDown = 0x2a,
        /// <summary>
        /// tO]Reg 0x2b (data) 
        /// </summary>
        ReverseFlag = 0x2b,
        /// <summary>
        /// Xebv㉺Reg 0x2c (data) 
        /// </summary>
        BranchStep = 0x2c,
        /// <summary>
        /// ^[o߃Reg 0x2d (standard) 
        /// </summary>
        ElapseTime = 0x2d,
        /// <summary>
        /// xReg 0x2e (utility) 
        /// </summary>
        BranchLevel = 0x2e,
        /// <summary>
        /// ԔReg 0x2f (utility)
        /// </summary>
        BranchStatus = 0x2f,

        /// <summary>
        /// lReg 0x30 (utility) 
        /// </summary>
        BranchPartyNumber = 0x30,
        /// <summary>
        /// p[eB[\Reg 0x31 (visual) 
        /// </summary>
        ShowParty = 0x31,
        /// <summary>
        /// p[eB[BReg 0x32 (visual) 
        /// </summary>
        HideParty = 0x32,
        /// <summary>
        /// ʒfReg 0x33 (terminal) 
        /// </summary>
        EffectBreak = 0x33,
        /// <summary>
        /// X^[gR[Reg 0x34 (standard)
        /// </summary>
        CallStart = 0x34,
        /// <summary>
        /// pbP[WNReg 0x35 (terminal) 
        /// </summary>
        LinkPackage = 0x35,
        /// <summary>
        /// pbP[WR[Reg 0x36 (standard) 
        /// </summary>
        CallPackage = 0x36,
        /// <summary>
        /// GAReg 0x37 (utility) 
        /// </summary>
        BranchArea = 0x37,
        /// <summary>
        /// ogReg 0x38 (utility) 
        /// </summary>
        BranchBattle = 0x38,
        /// <summary>
        /// I󕪊Reg 0x39 (branch) 
        /// </summary>
        BranchStamp = 0x39,
        /// <summary>
        /// ItReg 0x3a (get) 
        /// </summary>
        GetStamp = 0x3a,
        /// <summary>
        /// I폜Reg 0x3b (lost) 
        /// </summary>
        LostStamp = 0x3b,
        /// <summary>
        /// SVbvReg 0x3c (branch) 
        /// </summary>
        BranchGossip = 0x3c,
        /// <summary>
        /// SVbvǉReg 0x3d (get) 
        /// </summary>
        GetGossip = 0x3d,
        /// <summary>
        /// SVbv폜Reg 0x3e (lost) 
        /// </summary>
        LostGossip = 0x3e,
        /// <summary>
        /// og蕪Reg 0x3f (utility) 
        /// </summary>
        BranchIsBattle = 0x3f,

        /// <summary>
        /// ʍč\zReg 0x40 (visual) 
        /// </summary>
        ReDisplay = 0x40,
        /// <summary>
        /// tOReg 0x41 (data) 
        /// </summary>
        CheckFlag = 0x41,
        /// <summary>
        /// XebvReg 0x42 (data) 
        /// </summary>
        SubstituteStep = 0x42,
        /// <summary>
        /// tOReg 0x43 (data) 
        /// </summary>
        SubstituteFlag = 0x43,
        /// <summary>
        /// XebvrReg 0x44 (data) 
        /// </summary>
        BranchStepCmp = 0x44,
        /// <summary>
        /// tOrReg 0x45 (data)
        /// </summary>
        BranchFlagCmp = 0x45,
        /// <summary>
        /// _IReg 0x46 (utility)
        /// </summary>
        RandomSelect = 0x46,
        /// <summary>
        /// L[R[hReg 0x47 (branch)
        /// </summary>
        BranchKeyCode = 0x47,
        /// <summary>
        /// Xebv 0x48 (data)
        /// </summary>
        CheckStep = 0x48
    }
}