using System;
using System.IO;
using System.Text;
using System.Collections.Generic;


namespace Compiler.Data
{
    /// <summary>
    /// ogt@CɂGl~[J[h̃f[^
    /// </summary>
    public class EnemyData : FileIO
    {

        #region vpeB
        /// <summary>
        /// LXgiGl~[j̃J[hԍ
        /// </summary>
        public uint CastNumber
        {
            get { return castNumber; }
            set { castNumber = value; }
        }
        uint castNumber;
        /// <summary>
        /// Gl~[CxgXg
        /// </summary>
        public List<EventData> Events
        {
            get
            {  
                return eventList;
            }
        }
        List<EventData> eventList = new List<EventData>();
        /// <summary>
        /// QƃtO
        /// </summary>
        /// <param name="w"></param>
        public string FlagName
        {
            get { return flag; }
            set { flag = value; }
        }
        string flag;
        /// <summary>
        /// J[hTCYBXP[BP
        /// </summary>
        public uint Scale
        {
            get { return scale; }
            set
            {
                if (value < Const.CardScaleMin)
                    scale = Const.CardScaleMin;
                else if (value > Const.CardScaleMax)
                    scale = Const.CardScaleMax;
                else
                    scale = value;
            }
        }
        uint scale;
        /// <summary>
        /// XW
        /// </summary>
        public int Left
        {
            get { return left; }
            set { left = value; }
        }
        int left;
        /// <summary>
        /// YW
        /// </summary>
        public int Top
        {
            get { return top; }
            set { top = value; }
        }
        int top;
        /// <summary>
        /// ̉\
        /// </summary>
        public bool RunAway
        {
            get { return !(escape == 0); }
            set { escape = (byte)(value ? 1 : 0); }
        }
        byte escape;
        #endregion

        #region ToString
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();

            sb.AppendLine(".Enemy");

            //Cxg
            foreach (EventData eve in this.Events)
            {
                sb.Append(eve.ToString());
            }

            sb.AppendLine("@Enemy");

            return sb.ToString();
        }
        #endregion

        #region [hCg
        public override void Read(ShiftJisReader r)
        {
            castNumber = r.ReadUInt32();
            uint count = r.ReadUInt32();
            for (; count > 0; count--)
            {
                EventData ev = new EventData();
                ev.Read(r);
                Events.Add(ev);
            }
            flag = r.ReadString();
            scale = r.ReadUInt32();
            left = r.ReadInt32();
            top = r.ReadInt32();
            escape = r.ReadByte();
        }
        public override void Write(ShiftJisWriter w)
        {
            w.Write(castNumber);
            w.Write(Events.Count);
            foreach (EventData ev in Events)
                ev.Write(w);
            w.Write(flag);
            w.Write(scale);
            w.Write(left);
            w.Write(top);
            w.Write(escape);
        }
        #endregion
    }//class EnemyData
}
