
using System;
using System.Text;
using System.Collections.Generic;
using System.IO;

namespace Compiler.Data
{
    public class MenuData : FileIO
    {

        #region vpeB

        byte kindp;

        /// <summary>
        /// C[W
        /// </summary>
        public ImageData Image
        {
            get { return image; }
        }
        ImageData image = new ImageData();
        /// <summary>
        /// j[J[h
        /// </summary>
        public string CardName
        {
            get { return name; }
            set { value = name; }
        }
        string name;
        /// <summary>
        /// o[W
        /// </summary>
        public uint Version
        {
            get { return version; }
            set { version = value; }
        }
        uint version;
        /// <summary>
        /// J[h
        /// </summary>
        public string Expression
        {
            get { return expression; }
            set { expression = value; }
        }
        string expression;
        /// <summary>
        /// CxgXg
        /// </summary>
        public List<EventData> Events
        {
            get
            {  
                return eventList;
            }
        }
        List<EventData> eventList = new List<EventData>();
        /// <summary>
        /// QƃtO
        /// </summary>
        /// <param name="w"></param>
        public string FlagName
        {
            get { return flag; }
            set { flag = value; }
        }
        string flag;
        /// <summary>
        /// J[hTCYBXP[BP
        /// </summary>
        public uint Scale
        {
            get { return scale; }
            set
            {
                if (value < Const.CardScaleMin)
                    scale = Const.CardScaleMin;
                else if (value > Const.CardScaleMax)
                    scale = Const.CardScaleMax;
                else
                    scale = value;
            }
        }
        uint scale;
        /// <summary>
        /// X
        /// </summary>
        public int Left
        {
            get { return left; }
            set { left = value; }
        }
        int left;
        /// <summary>
        /// Y
        /// </summary>
        public int Top
        {
            get { return top; }
            set { top = value; }
        }
        int top;
        /// <summary>
        /// C[WQƂ̏ꍇ̉摜t@C
        /// </summary>
        public string ImageFileName
        {
            get { return imageFile; }
            set { imageFile = value; }
        }
        string imageFile;
        #endregion

        public MenuData() {  }


        #region [hCg
        public override void Read(ShiftJisReader r)
        {
            

            kindp = r.ReadByte();
            image.Read(r);
            name = r.ReadString();
            version = r.ReadUInt32();
            expression = r.ReadString();
            uint count = r.ReadUInt32();
            for (; count > 0; count--)
            {
                EventData ev = new EventData();
                ev.Read(r);
                Events.Add(ev);
            }
            flag = r.ReadString();
            scale = r.ReadUInt32();
            left = r.ReadInt32();
            top = r.ReadInt32();
            imageFile = r.ReadString();
        }
        public override void Write(ShiftJisWriter w)
        {
            w.Write(kindp);
            image.Write(w);
            w.Write(name);
            w.Write(version);
            w.Write(expression);
            w.Write(Events.Count);
            foreach (EventData ev in Events)
                ev.Write(w);
            w.Write(flag);
            w.Write(scale);
            w.Write(left);
            w.Write(top);
            w.Write(imageFile);
        }
        #endregion

    }//class MenuData
}
