using System;
using System.Collections.Generic;
using System.IO;
using System.Text;

namespace Compiler.Data
{

    public class WidArea : FileIO
    {

        #region vpeB
        /// <summary>
        /// GA2Œ̂͂EE
        /// </summary>
        public WidIDtype WidID
        {
            get { return (WidIDtype)widid; }
        }
        byte widid;
        /// <summary>
        /// NULLC[W
        /// </summary>
        public ImageData Image
        {
            get { return nullImage; }
        }
        ImageData nullImage = new ImageData();
        /// <summary>
        /// GA̖O
        /// </summary>
        public string AreaName
        {
            get { return name; }
            set { name = value; }
        }
        string name;
        /// <summary>
        /// o[W
        /// </summary>
        public uint Version
        {
            get { return numberANDversion / Const.VersionOffset; }
            set { numberANDversion = FileNumber + value * Const.VersionOffset; }
        }
        uint numberANDversion;
        /// <summary>
        /// GAԍ
        /// </summary>
        public uint FileNumber
        {
            get { return numberANDversion % Const.VersionOffset; }
            set { numberANDversion = value + Version * Const.VersionOffset; }
        }
        /// <summary>
        /// CxgXg
        /// </summary>
        public List<EventData> Events
        {
            get
            {    
                return eventList;
            }
        }
        List<EventData> eventList = new List<EventData>();
        /// <summary>
        /// J[hʒu蓮ݒ肪true, łfalse
        /// </summary>
        public bool CustomCardPosition
        {
            get { return !(custom == 0); }
            set { custom = (byte)(value ? 1 : 0); }
        }
        byte custom;
        /// <summary>
        /// j[Xg
        /// </summary>
        public List<MenuData> Menus
        {
            get
            {   
                return menuList;
            }
        }
        List<MenuData> menuList = new List<MenuData>();
        /// <summary>
        /// wiZXg
        /// </summary>
        public List<CellData> Cells
        {
            get
            {
                return cellList;
            }
        }
        List<CellData> cellList = new List<CellData>();
        #endregion

        public WidArea() {  }

        public WidArea(string fullpath) : base(fullpath) { }

        #region [hCg
        public override void Read(ShiftJisReader r)
        {
            widid = r.ReadByte();
            nullImage.Read(r);
            name = r.ReadString();
            numberANDversion = r.ReadUInt32();
            uint count = r.ReadUInt32();
            for (; count > 0; count--)
            {
                EventData ev = new EventData();
                ev.Read(r);
                Events.Add(ev);
            }
            custom = r.ReadByte();
            count = r.ReadUInt32();
            for (; count > 0; count--)
            {
                MenuData mn = new MenuData();
                mn.Read(r);
                Menus.Add(mn);
            }
            count = r.ReadUInt32();
            for (; count > 0; count--)
            {
                CellData cl = new CellData();
                cl.Read(r);
                Cells.Add(cl);
            }
        }
        public override void Write(ShiftJisWriter w)
        {
            w.Write(widid);
            nullImage.Write(w);
            w.Write(name);
            w.Write(numberANDversion);
            w.Write(Events.Count);
            foreach (EventData ev in Events)
                ev.Write(w);
            w.Write(custom);
            w.Write(Menus.Count);
            foreach (MenuData mn in Menus)
                mn.Write(w);
            w.Write(Cells.Count);
            foreach (CellData cl in Cells)
                cl.Write(w);
        }
        #endregion

    }//class WidArea
}
