using System;
using System.Text;
using System.IO;
using System.Collections.Generic;

namespace Compiler.Data
{

    /// <summary>
    /// ogt@C̃f[^
    /// </summary>
    public class WidBattle : FileIO
    {

        #region vpeB
        /// <summary>
        /// og1Œ̂͂EE
        /// </summary>
        public WidIDtype WidID
        {
            get { return (WidIDtype)widid; }
        }
        byte widid;
        /// <summary>
        /// C[W
        /// </summary>
        public ImageData Image
        {
            get { return nullImage; }
        }
        ImageData nullImage = new ImageData();
        /// <summary>
        /// og̖O
        /// </summary>
        public string BattleName
        {
            get { return name; }
            set { name = value; }
        }
        string name;
        /// <summary>
        /// o[W
        /// </summary>
        public uint Version
        {
            get { return numberANDversion / Const.VersionOffset; }
            set { numberANDversion = FileNumber + value * Const.VersionOffset; }
        }
        uint numberANDversion;
        /// <summary>
        /// ogԍ
        /// </summary>
        public uint FileNumber
        {
            get { return numberANDversion % Const.VersionOffset; }
            set { numberANDversion = value + Version * Const.VersionOffset; }
        }
        /// <summary>
        /// CxgXg
        /// </summary>
        public List<EventData> Events
        {
            get
            {  
                return eventList;
            }
        }
        List<EventData> eventList = new List<EventData>();
        /// <summary>
        /// J[hʒu蓮ݒ肪true, łfalse
        /// </summary>
        public bool CustomCardPosition
        {
            get { return !(custom == 0); }
            set { custom = (byte)(value ? 1 : 0); }
        }
        byte custom;
        /// <summary>
        /// GXg
        /// </summary>
        public List<EnemyData> Enemies
        {
            get
            {
                return enemyList;
            }
        }
        List<EnemyData> enemyList = new List<EnemyData>();
        /// <summary>
        /// BGM
        /// </summary>
        public string BGMFile
        {
            get { return bgmFilename; }
            set { bgmFilename = value; }
        }
        string bgmFilename;
        #endregion

        public WidBattle() {  }

        public WidBattle(string fullpath) : base(fullpath) { }

        #region [hCg
        public override void Read(ShiftJisReader r)
        {
            widid = r.ReadByte();
            nullImage.Read(r);
            name = r.ReadString();
            numberANDversion = r.ReadUInt32();
            uint count = r.ReadUInt32();
            for (; count > 0; count--)
            {
                EventData ev = new EventData();
                ev.Read(r);
                Events.Add(ev);
            }
            custom = r.ReadByte();
            count = r.ReadUInt32();
            for (; count > 0; count--)
            {
                EnemyData em = new EnemyData();
                em.Read(r);
                Enemies.Add(em);
            }
            bgmFilename = r.ReadString();
        }
        public override void Write(ShiftJisWriter w)
        {
            w.Write(widid);
            nullImage.Write(w);
            w.Write(name);
            w.Write(numberANDversion);
            w.Write(Events.Count);
            foreach (EventData ev in Events)
                ev.Write(w);
            w.Write(custom);
            w.Write(Enemies.Count);
            foreach (EnemyData em in Enemies)
                em.Write(w);
            w.Write(bgmFilename);
        }
        #endregion

    }//class WidBattle
}
