using System;
using System.Text;
using System.IO;
using System.Collections.Generic;
using System.Collections.Specialized;

namespace Compiler.Data
{
    public class WidPackage : FileIO
    {
        #region vpeB
        /// <summary>
        /// o[W
        /// </summary>
        public uint Version
        {
            get { return version; }
            set { version = value; }
        }
        uint version;
        /// <summary>
        /// pbP[W
        /// </summary>
        public string PackageName
        {
            get { return name; }
            set { name = value; }
        }
        string name;
        /// <summary>
        /// pbP[WID
        /// </summary>
        public uint PackageNumber
        {
            get { return number; }
            set { number = value; }
        }
        uint number;
        /// <summary>
        /// CxgXg
        /// </summary>
        public List<EventData> Events
        {
            get
            {   
                return eventList;
            }
        }
        List<EventData> eventList = new List<EventData>();
        #endregion

        public WidPackage() {  }

        public WidPackage(string fullpath) : base(fullpath) { }


        #region [hCg
        public override void Read(ShiftJisReader r)
        {
            version = r.ReadUInt32();
            name = r.ReadString();
            number = r.ReadUInt32();
            uint count = r.ReadUInt32();
            EventData ev;
            for (; count > 0; count--)
            {
                ev = new EventData(false);
                ev.Read(r);
                Events.Add(ev);
            }
        }
        public override void Write(ShiftJisWriter w)
        {
            w.Write(version);
            w.Write(name);
            w.Write(number);
            w.Write(Events.Count);
            foreach (EventData e in Events)
                e.Write(w);
        }
        #endregion

    }//class WidPackage
}
